<!-- Begin
sortitems = 0;  // Automatically sort items within lists? (1 or 0)

function add(input,tbox) {
  trim(input);  //trim the value
  if(input.value != "") {
    if (repeat(input.value,tbox)) {
      input.value = "";
      return false;
    }
    if (!isValid(input.value)) return false; 
    var no = new Option();
    no.value = input.value;
    no.text = no.value;
    tbox.options[tbox.options.length] = no;
    input.value = "";
    if (sortitems) SortD(tbox);
    return true;
  }
}

function add2(input,tbox) {
  trim(input);  //trim the value
  if(input.value != "") {
    if (repeat(input.value,tbox)) {
      return false;
    }
    if (!isValid(input.value)) return false; 
    var no = new Option();
    no.value = input.value;
    no.text = no.value;
    tbox.options[tbox.options.length] = no;
    if (sortitems) SortD(tbox);
    return true;
  }
}

function add3(input,item, tbox) {  //item is an option
  trim(input);  //trim the value
  if(input.value != "") {
    if (repeat3(input.value,tbox, ' -- ')) {
      input.value = "";
      return false;
    }
    if (!isValid(input.value)) return false; 
    if (!isValid2(input.value)) return false; 
    var no = new Option();
    no.value = input.value + ' -- ' + item.value;
    no.text = input.value + ' -- '+ item.text;
    tbox.options[tbox.options.length] = no;
    input.value = "";
    return true;
  }
}

function set2(fbox,fbox2,tbox, msg, msg2) {
  var o1 = selected(fbox, msg);
  if (o1 == null) return false;
  var o2 = selected2(fbox2, msg2);
  if (o2 == null) {
    o1.selected=true;
    return false;
  }
  if (repeat3(o1.value,tbox, ' : ')) {
    o1.selected=false;
    return false;
  }
  var no = new Option();
  no.value = o1.value + ' : ' + o2[0].value;
  no.text = o1.text + ' : ' + o2[0].text;
  
  for (var i=1; i<o2.length; i++) {
    no.value += (';' + o2[i].value);
    no.text += (';' + o2[i].text);
  }

  tbox.options[tbox.options.length] = no;
  o1.value="";
  o1.text="";
  BumpUp(fbox);
  return true;
}

function move2(fbox,tbox) {
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      var v_index = fbox.options[i].value.indexOf(' : ');
      var v = fbox.options[i].value.substring(0, v_index);
      var t_index = fbox.options[i].text.indexOf(' : ');
      var t = fbox.options[i].text.substring(0, t_index);
      if (!repeatSilent(v,tbox)) {
        var no = new Option();
        no.value = v;
        no.text = t;
        tbox.options[tbox.options.length] = no;
      }
      fbox.options[i].value = "";
      fbox.options[i].text = "";
    }
  }
  BumpUp(fbox);
  if (sortitems) SortD(tbox);
}

function remove1(fbox) {
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      if (confirm("'"+fbox.options[i].text+"' will be removed!") == true) {
        fbox.options[i].value = "";
        fbox.options[i].text = "";
      }
    }
  }
  BumpUp(fbox);
}

function remove2(fbox, item) {
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].value == item) {
      fbox.options[i].value = "";
      fbox.options[i].text = "";
    }
  }
  BumpUp(fbox);
}

function move(fbox,tbox) {
  var moved = 0
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      if (!repeat(fbox.options[i].value,tbox)) {
        var no = new Option();
        no.value = fbox.options[i].value;
        no.text = fbox.options[i].text;
        tbox.options[tbox.options.length] = no;
      }
      fbox.options[i].value = "";
      fbox.options[i].text = "";
      moved = 1;
    }
  }
  BumpUp(fbox);
  if (sortitems) SortD(tbox);
  return moved;
}

function move255(fbox,tbox) {
  var len = tbox.options.length - 1;
  for(var i=0; i<tbox.options.length; i++) {
     len += tbox.options[i].value.length;
  }
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      if (!repeat(fbox.options[i].value,tbox)) {
        len += (1 + fbox.options[i].value.length);
      }
    }
  }
  if (len > 255) {
    alert("Total length of items in the target field has exceeded the limit 255");
    return false;
  }	
  move(fbox,tbox); 
}

function copy(fbox,tbox) {
  tbox.options.length = fbox.options.length;
  for(var i=0; i<fbox.options.length; i++) {
    var no = new Option();
    no.value = fbox.options[i].value;
    no.text = fbox.options[i].text;
    tbox.options[i] = no;
  }
}

function BumpUp(box) {
  for(var i=0; i<box.options.length; i++) {
    if(box.options[i].value == "")  {
      for(var j=i; j<box.options.length-1; j++)  {
        box.options[j].value = box.options[j+1].value;
        box.options[j].text = box.options[j+1].text;
      }
      var ln = i;
      break;
    }
  }
  if(ln < box.options.length) {
    box.options.length -= 1;
    BumpUp(box);
  }
}

function SortD(box) {
  var temp_opts = new Array();
  var temp = new Object();
  for(var i=0; i<box.options.length; i++) {
    temp_opts[i] = box.options[i];
  }
  for(var x=0; x<temp_opts.length-1; x++) {
    for(var y=(x+1); y<temp_opts.length; y++) {
      if(temp_opts[x].text > temp_opts[y].text) {
        temp = temp_opts[x].text;
        temp_opts[x].text = temp_opts[y].text;
        temp_opts[y].text = temp;
        temp = temp_opts[x].value;
        temp_opts[x].value = temp_opts[y].value;
        temp_opts[y].value = temp;
      }
    }
  }
  for(var i=0; i<box.options.length; i++)  {
    box.options[i].value = temp_opts[i].value;
    box.options[i].text = temp_opts[i].text;
  }
}

function trim(input) {
  var str = input.value;
  while(''+str.charAt(0)==' ' || ''+str.charAt(0)=='\n' || ''+str.charAt(0)=='\r') {
    str=str.substring(1,str.length);
  }
  while(''+str.charAt(str.length-1)==' ') {
    str=str.substring(0,str.length-1);
  }
  input.value=str;
}

function repeat(str,tbox) {
  for(var i=0; i<tbox.options.length; i++) {
    var s = tbox.options[i].value;
    if(s.toUpperCase() == str.toUpperCase()) { 
      alert("Field item already exists: " + s);
      return true;
    }
  }
  return false;
}

function repeatSilent(str,tbox) {
  for(var i=0; i<tbox.options.length; i++) {
    var s = tbox.options[i].value;
    if(s.toUpperCase() == str.toUpperCase()) { 
      return true;
    }
  }
  return false;
}

function repeat3(str,tbox, delim) {
  for(var i=0; i<tbox.options.length; i++) {
    var s = tbox.options[i].value;
    var s_index = s.indexOf(delim);
    var area = s.substring(0, s_index);
    if(area.toUpperCase() == str.toUpperCase()) { 
      alert("Field item already exists: " + area);
      return true;
    }
  }
  return false;
}

function selected(fbox, msg) {
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      fbox.options[i].selected=false;
      return fbox.options[i];
    } 
  }
  alert(msg)
  return null;
}

function selected2(fbox, msg) {
  var result = null;
  var j = 0;
  for(var i=0; i<fbox.options.length; i++) {
    if(fbox.options[i].selected && fbox.options[i].value != "") {
      fbox.options[i].selected=false;
      if (result == null) {
        result = new Array();
      }
      result[j++] = fbox.options[i];
    } 
  }

  if (result == null) {
    alert(msg)
  }
  return result;
}

function selectAll(fbox) {
  for(var i=0; i<fbox.options.length; i++) {
    fbox.options[i].selected=true;
  }
  return true;
}

function selectAllRequired(fbox, msg) {
  if(fbox.options.length < 1) {
    alert (msg)
    return false;
  }
  return selectAll(fbox);
}

function isAdded(fbox, item, msg) {
  for(var i=0; i<fbox.options.length; i++) {
    if (fbox.options[i].value.toUpperCase()==item.toUpperCase())
      return true;
  }
  alert (msg)
  return false;
}

function isValid(str) {
  for (var i=0; i<str.length; i++) {
    var ch = str.charAt(i);
    if (ch == '"'
        || ch == '+'
        || ch == ';'
        || ch == '?'
        || ch == '*'
        || ch == '$') {
      alert("Field value should not contain: " + ch);
      return false;
    }
  }
  return true;
}

function isValid2(str) {
  for (var i=0; i<str.length; i++) {
    if (str.charAt(i) == '-') {
      if (i<str.length-1 && str.charAt(i+1) == '-') {
        alert("Field value should not contain: --");
        return false;
      }
    }
  }
  return true;
}
// End -->
